import 'dart:convert';
import 'dart:typed_data';

import 'package:diplomaticquarterapp/config/shared_pref_kay.dart';
import 'package:diplomaticquarterapp/core/viewModels/project_view_model.dart';
import 'package:diplomaticquarterapp/locator.dart';
import 'package:diplomaticquarterapp/models/Appointments/AppoimentAllHistoryResultList.dart';
import 'package:diplomaticquarterapp/models/Appointments/DoctorListResponse.dart';
import 'package:diplomaticquarterapp/models/Appointments/PatientShareResposne.dart';
import 'package:diplomaticquarterapp/models/Authentication/authenticated_user.dart';
import 'package:diplomaticquarterapp/routes.dart';
import 'package:diplomaticquarterapp/services/appointment_services/GetDoctorsList.dart';
import 'package:diplomaticquarterapp/uitl/app_shared_preferences.dart';
import 'package:diplomaticquarterapp/uitl/app_toast.dart';
import 'package:diplomaticquarterapp/uitl/date_uitl.dart';
import 'package:diplomaticquarterapp/uitl/gif_loader_dialog_utils.dart';
import 'package:diplomaticquarterapp/uitl/translations_delegate_base.dart';
import 'package:diplomaticquarterapp/widgets/buttons/defaultButton.dart';
import 'package:diplomaticquarterapp/widgets/dialogs/confirm_dialog.dart';
import 'package:diplomaticquarterapp/widgets/nfc/nfc_reader_sheet.dart';
import 'package:diplomaticquarterapp/widgets/others/app_scaffold_widget.dart';
import 'package:flutter/material.dart';
import 'package:flutter_nfc_kit/flutter_nfc_kit.dart';

class QRCode extends StatefulWidget {
  PatientShareResponse patientShareResponse;
  AppoitmentAllHistoryResultList appointment;
  String appoQR;
  AuthenticatedUser authUser;
  AppSharedPreferences sharedPref = AppSharedPreferences();

  QRCode({@required this.patientShareResponse, @required this.appoQR, @required this.appointment});

  @override
  _QRCodeState createState() => _QRCodeState();
}

class _QRCodeState extends State<QRCode> {
  Uint8List _bytes;
  bool _supportsNFC = false;
  BuildContext _context;

  @override
  void initState() {
    // TODO: implement initState

    _bytes = base64.decode(widget.appoQR.split(',').last);
    widget.authUser = new AuthenticatedUser();

    FlutterNfcKit.nfcAvailability.then((value) {
      _supportsNFC = (value == NFCAvailability.available);
    });

    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    _context = context;
    return AppScaffold(
      appBarTitle: TranslationBase.of(context).attendRegisterCode,
      isShowAppBar: true,
      showNewAppBar: true,
      showNewAppBarTitle: true,
      body: SingleChildScrollView(
        child: Container(
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            mainAxisSize: MainAxisSize.max,
            children: <Widget>[
              Container(
                width: double.infinity,
                height: MediaQuery.of(context).size.width / 3,
                child: Row(
                  children: [
                    _supportsNFC
                        ? Expanded(
                            flex: 1,
                            child: Row(
                              crossAxisAlignment: CrossAxisAlignment.center,
                              mainAxisAlignment: MainAxisAlignment.center,
                              children: [
                                InkWell(
                                  child: Container(
                                    margin: EdgeInsets.only(top: 30.0),
                                    alignment: Alignment.center,
                                    padding: EdgeInsets.all(8),
                                    decoration: BoxDecoration(
                                      border: Border.all(color: Colors.black),
                                      borderRadius: BorderRadius.circular(10),
                                    ),
                                    child: Image.asset("assets/images/nfc/ic_nfc.png"),
                                  ),
                                  onTap: () {
                                    locator<ProjectViewModel>().analytics.todoList.to_do_list_nfc(widget.appointment);
                                    showNfcReader(context, onNcfScan: (String nfcId) {
                                      Future.delayed(const Duration(milliseconds: 100), () {
                                        sendNfcCheckInRequest(nfcId);
                                      });
                                    }, onCancel: (){
                                      locator<ProjectViewModel>().analytics.todoList.to_do_list_nfc_cancel(widget.appointment);
                                    });
                                  },
                                ),
                              ],
                            ),
                          )
                        : Container(),
                    Expanded(
                      flex: 1,
                      child: Container(
                        margin: EdgeInsets.only(top: 30.0),
                        alignment: Alignment.center,
                        child: Image.memory(
                          _bytes,
                        ),
                      ),
                    ),
                  ],
                ),
              ),
              Container(
                margin: EdgeInsets.only(top: 20.0, left: 20.0, right: 20.0),
                child: Divider(
                  color: Colors.red[700],
                  thickness: 0.8,
                ),
              ),
              Container(
                child: Row(
                  children: <Widget>[
                    Container(
                      margin: EdgeInsets.only(top: 10.0, left: 40.0, bottom: 10.0),
                      child: Image.asset("assets/images/new-design/device_icon.png", width: MediaQuery.of(context).size.width / 3.4, height: MediaQuery.of(context).size.width / 3.4),
                    ),
                    Expanded(
                      child: Container(
                        width: double.infinity,
                        margin: EdgeInsets.only(top: 15.0, bottom: 10.0, left: 20.0, right: 20.0),
                        child: Text(TranslationBase.of(context).scanQRHospital, style: TextStyle(color: Colors.red[700], fontSize: 18.0, fontWeight: FontWeight.bold)),
                      ),
                    ),
                  ],
                ),
              ),
              Container(
                margin: EdgeInsets.only(top: 10.0, left: 20.0, right: 20.0),
                child: Divider(
                  color: Colors.red[700],
                  thickness: 0.8,
                ),
              ),
              Container(
                margin: EdgeInsets.only(top: 15.0, bottom: 10.0, left: 20.0, right: 20.0),
                child: Text(TranslationBase.of(context).appoInfo, style: TextStyle(fontSize: 18.0, color: Colors.grey[700], fontWeight: FontWeight.bold)),
              ),
              Container(
                margin: EdgeInsets.only(left: 20.0, bottom: 20.0, right: 20.0),
                decoration: BoxDecoration(
                  borderRadius: BorderRadius.circular(10),
                  color: Colors.grey[200],
                  boxShadow: [
                    BoxShadow(color: Colors.grey, spreadRadius: 2),
                  ],
                ),
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: <Widget>[
                    Container(
                      margin: EdgeInsets.only(top: 15.0, bottom: 10.0, left: 20.0, right: 20.0),
                      child: Text(widget.patientShareResponse.doctorNameObj, style: TextStyle(fontSize: 18.0, color: Colors.grey[700], fontWeight: FontWeight.bold)),
                    ),
                    if (getDoctorSpeciality(widget.patientShareResponse.doctorSpeciality) != "null\n")
                      Container(
                        margin: EdgeInsets.only(bottom: 10.0, left: 20.0, right: 20.0),
                        child: Text(getDoctorSpeciality(widget.patientShareResponse.doctorSpeciality), style: TextStyle(fontSize: 18.0, color: Colors.grey[700])),
                      ),
                    Container(
                      margin: EdgeInsets.only(top: 0.0, bottom: 10.0, left: 20.0, right: 20.0),
                      child: Text(widget.patientShareResponse.projectName, style: TextStyle(fontSize: 18.0, color: Colors.grey[700])),
                    ),
                    Container(
                      margin: EdgeInsets.only(top: 0.0, bottom: 10.0, left: 20.0, right: 20.0),
                      child: Text(getDate(widget.patientShareResponse.appointmentDate), style: TextStyle(fontSize: 18.0, color: Colors.grey[700])),
                    ),
                  ],
                ),
              ),
              Container(
                margin: EdgeInsets.only(left: 20.0, right: 20.0, top: 15.0),
                alignment: Alignment.bottomCenter,
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.end,
                  children: <Widget>[
                    DefaultButton(TranslationBase.of(context).sendEmail.toUpperCase(), () => {sendEmail()})
                  ],
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }

  sendEmail() async {
    DoctorsListService service = new DoctorsListService();

    if (await widget.sharedPref.getObject(USER_PROFILE) != null) {
      var data = AuthenticatedUser.fromJson(await widget.sharedPref.getObject(USER_PROFILE));
      setState(() {
        widget.authUser = data;
      });
    }

    ConfirmDialog dialog = new ConfirmDialog(
        context: context,
        confirmMessage: "Send a copy of this QR to the email " + widget.authUser.emailAddress + "?",
        okText: TranslationBase.of(context).confirm,
        cancelText: TranslationBase.of(context).cancel_nocaps,
        okFunction: () {
          GifLoaderDialogUtils.showMyDialog(context);
          service
              .sendAppointmentQREmail(widget.authUser.emailAddress, widget.patientShareResponse.appointmentDate, widget.patientShareResponse.appointmentNo.toString(),
                  widget.patientShareResponse.doctorNameObj, widget.patientShareResponse.projectName, widget.appoQR, getDoctorSpeciality(widget.patientShareResponse.doctorSpeciality), context)
              .then((res) {
            GifLoaderDialogUtils.hideDialog(context);
            ConfirmDialog.closeAlertDialog(context);
          }).catchError((err) {
            ConfirmDialog.closeAlertDialog(context);
            GifLoaderDialogUtils.hideDialog(context);
            AppToast.showErrorToast(message: err);
            print(err);
          });
        },
        cancelFunction: () => {});
    dialog.showAlertDialog(context);
  }

  Future navigateToHome(context) async {
    Navigator.of(context).pushNamed(HOME);
  }

  getPatientShare(context, String appointmentNo, int clinicID, int projectID, DoctorList docObject) {}

  String getDate(String appoDate) {
    var appoDateFormatted = "";

    var dateObj = DateUtil.convertStringToDate(appoDate);

    setState(() {
      appoDateFormatted = DateUtil.getWeekDay(dateObj.weekday) +
          ", " +
          dateObj.day.toString() +
          " " +
          DateUtil.getMonth(dateObj.month) +
          " " +
          dateObj.year.toString() +
          ", " +
          dateObj.hour.toString() +
          ":" +
          dateObj.minute.toString() +
          ":00";
    });

    return appoDateFormatted;
  }

  String getDoctorSpeciality(List<String> docSpecial) {
    String docSpeciality = "";
    if (docSpecial != null && docSpecial.length != 0) {
      docSpecial.forEach((v) {
        docSpeciality = docSpeciality + v + "\n";
      });
    }
    return docSpeciality;
  }

  sendNfcCheckInRequest(String nfcId) {
    GifLoaderDialogUtils.showMyDialog(context);

    DoctorsListService service = new DoctorsListService();

    service.sendCheckinNfcRequest(widget.patientShareResponse.appointmentNo, nfcId, widget.patientShareResponse.projectID, context).then((res) {
      print(res);

      GifLoaderDialogUtils.hideDialog(context);
      _showMyDialog(res["SuccessMsg"], this.context);
    }).catchError((err) {
      GifLoaderDialogUtils.hideDialog(context);
      print(err);
      _showMyDialog(err, this.context);
    });
  }

  Future<void> _showMyDialog(String message, BuildContext context) async {
    return showDialog<void>(
      context: context,
      barrierDismissible: true, // user must tap button!
      builder: (BuildContext context) {
        return AlertDialog(
          title: const Text('Alert'),
          content: SingleChildScrollView(
            child: ListBody(
              children: <Widget>[
                Text(message),
              ],
            ),
          ),
          actions: <Widget>[
            TextButton(
              child: const Text('OK'),
              onPressed: () {
                Navigator.of(context).pop();
              },
            ),
          ],
        );
      },
    );
  }
}
